package io.github.lonamiwebs.overgram.tl;

import io.github.lonamiwebs.overgram.utils.BinaryReader;
import io.github.lonamiwebs.overgram.utils.BinaryWriter;

import java.util.ArrayList;
import java.util.List;

public class MessageContainer extends TLObject {
    public static final int CONSTRUCTOR_ID = 1945237724;

    final public List<TLMessage> messages = new ArrayList<>();

    @Override
    public void serialize(final BinaryWriter writer) {
        writer.write(CONSTRUCTOR_ID);
        writer.write(messages.size());
        for (final TLMessage message : messages) {
            writer.write(message);
        }
    }

    @Override
    public void deserialize(final BinaryReader reader) throws ClassNotFoundException {
        messages.clear();
        final int count = reader.readInt();
        for (int i = 0; i < count; ++i) {
            final TLMessage message = new TLMessage();
            message.deserialize(reader);
            messages.add(message);
        }
    }
}
